
#include <stdio.h>
#include <stdlib.h>
#include "myppm.h"

/************************************************************************
  Adds a border of width one around a ppm file in rawbits format (P6)
**************************************************************************/

main(int argc, char *argv[])
{
    int i,y,x,r,g,b ;
    int rside,lside,bside,tside ;
    PPMfile forig ;
    char *info = "Adds a border of one pixel width around a ppm file in\n"
	         "in rawbits format (P6)\n"
		 "color is given in r g b format with eah component 0-255.\n"
		 "By default all  sides are affected.\n"
		 "You can choose which sides will get a border by specifying\n"
		 "any of the [l r t b] combinations\n"
		 "CAUTION: if you specify sides you have to give a color too!\n" ;


    if ((argc != 3 ) && (argc < 6))
    {
	fprintf(stderr, "usage: %s ppm_file out_ppm_file [r g b l r t b]\n",argv[0]) ;
	fprintf(stderr,"%s: %s\n",argv[0],info) ;
	return -1 ;
    }

    if (argc > 3)
    {
	r = atoi(argv[3]) ;
	g = atoi(argv[4]) ;
	b = atoi(argv[5]) ;
    }
    else
    {
	r = 0 ; g = 0 ; b = 0 ;
    }

    if( argc > 6 ) // the user has specified sides so use them
    {
	rside = FALSE ;
	lside = FALSE ;
	tside = FALSE ;
	bside = FALSE ;

	// find which sides are specified
	for ( i = 6 ; i < argc ; i++ )
	{
	    switch(argv[i][0])
	    {
	    case 'r' : rside = TRUE ;
		break ;
	    case 'l' : lside = TRUE ;
		break ;
	    case 't' : tside = TRUE ;
		break ;
	    case 'b' : bside = TRUE ;
		break ;
		default : break ;
	    }
	}
    }
    else			// use default
    {
	rside = TRUE ;
	lside = TRUE ;
	tside = TRUE ;
	bside = TRUE ;
    }
    
    forig.read(argv[1]) ;
    x = forig.get_x() ;
    y = forig.get_y() ;
   
    for ( i = 0 ; i < x ; i++ )
    {
	if( lside == TRUE )
	{
	    forig.data[i][0].r = r ;
	    forig.data[i][0].g = g ;
	    forig.data[i][0].b = b ;
	}
       

	if( rside == TRUE )
	{
	    forig.data[i][y-1].r = r ;
	    forig.data[i][y-1].g = g ;
	    forig.data[i][y-1].b = b ;
	}
	
    }

    for ( i = 0 ; i < y ; i++ )
    {
	if( tside == TRUE )
	{
	    forig.data[0][i].r = r ;
	    forig.data[0][i].g = g ;
	    forig.data[0][i].b = b ;
	}
	
	if( bside == TRUE )
	{
	    forig.data[x-1][i].r = r ;
	    forig.data[x-1][i].g = g ;
	    forig.data[x-1][i].b = b ;
	}
       
    }

    forig.write(argv[2]) ;
    return 1 ;
}
    
    
	    
    
