#include <stdio.h>
#include <stdlib.h>
#include "myppm.h"

main(int argc, char *argv[])
{
    int i,j,x,y ;
    PPMfile forig,*ftar ;
    
    if( argc != 3 )
    {
	fprintf(stderr, "usage: %s in_file.ppm out_file.ppm \n",argv[0]) ;
	return -1 ;
    }

    forig.read(argv[1]) ;
    x = forig.get_x()  ;
    y = forig.get_y()  ;
    
    ftar = new PPMfile(x,y) ;
    strcpy(ftar->type,forig.type) ;
    ftar->maxval = forig.maxval ;
   
    for( i = 2 ; i < (x - 2) ; i++ )
	for( j = 2 ; j < (y -2)  ; j++ )
	{
	    ftar->data[i][j].r =
		(forig.data[i-1][j-1].r+forig.data[i-1][j].r + forig.data[i-1][j+1].r +
		5*forig.data[i][j].r + forig.data[i][j+1].r + forig.data[i][j-1].r +
		forig.data[i+1][j-1].r + forig.data[i+1][j].r + forig.data[i+1][j+1].r) / 14 ;
	    
	    ftar->data[i][j].g =
		(forig.data[i-1][j-1].g+forig.data[i-1][j].g + forig.data[i-1][j+1].g +
		5*forig.data[i][j].g + forig.data[i][j+1].g + forig.data[i][j-1].g +
		forig.data[i+1][j-1].g + forig.data[i+1][j].g + forig.data[i+1][j+1].g) / 14 ;

	    ftar->data[i][j].b =
		(forig.data[i-1][j-1].b+forig.data[i-1][j].b + forig.data[i-1][j+1].b +
		5*forig.data[i][j].b + forig.data[i][j+1].b + forig.data[i][j-1].b +
		forig.data[i+1][j-1].b + forig.data[i+1][j].b + forig.data[i+1][j+1].b) / 14 ;
	}

    for( i = 0 ; i < 2 ; i++ )
	for( j = 0 ; j < y ; j++ )
	    ftar->data[i][j] = forig.data[i][j] ;

    for( i = 0 ; i < 2 ; i++ )
	for( j = 0 ; j < x ; j++ )
	    ftar->data[j][i] = forig.data[j][i] ;

    for( i = x-2 ; i < x ; i++ )
	for( j = 0 ; j < y ; j++ )
	    ftar->data[i][j] = forig.data[i][j] ;
    
    for( i = y-2 ; i < y ; i++ )
	for( j = 0 ; j < x ; j++ )
	    ftar->data[j][i] = forig.data[j][i] ;

    ftar->write(argv[2]) ;
    return 1 ;
}
    
