
#include <stdio.h>
#include <stdlib.h>
#include "myppm.h"

/************************************************************************
  downscale2.c: Down scales a ppm image in rawbits format by 2 on each
               dimension. The dimension of the image do not have to be
	       multiples of 2. If they are not then the extra column/row
	       is ignored.
**************************************************************************/

main(int argc, char *argv[])
{
    int i,j,i_tar,j_tar,x4,y4 ;
    PPMfile forig, *ftar ;
    char *info = "Down scales a ppm image in rawbits format by 2 on each\n"
               "dimension. The dimension of the image do not have to be\n"
	       "multiples of 2. If they are not then the extra column/row\n"
	       "is ignored." ;

    if( argc != 3 )
    {
	fprintf(stderr, "usage: %s in_file out_file \n",argv[0]) ;
	fprintf(stderr,"donwscale2: %s\n",info) ;
	return -1 ;
    }
  
    forig.read(argv[1]) ;
    x4 = forig.get_x() / 2 ;		/* find out how many 2's  go in each direction */
    y4 = forig.get_y() / 2 ;
    
    printf("%d %d\n", x4,y4) ;

    ftar = new PPMfile(x4,y4) ;
    strcpy(ftar->type,forig.type) ;
    ftar->maxval = 255 ;

  
    for( i_tar = 0, i = 0 ; i_tar < x4 ; i_tar++, i += 2 )
    {
	for( j = 0, j_tar = 0 ; j_tar < y4 ; j_tar++, j += 2 )
	{
	   
	    ftar->data[i_tar][j_tar].r =  (forig.data[i][j].r + forig.data[i][j+1].r + 
					   forig.data[i+1][j].r+forig.data[i+1][j+1].r) / 4 ;
	    ftar->data[i_tar][j_tar].g =  (forig.data[i][j].g + forig.data[i][j+1].g + 
					   forig.data[i+1][j].g+forig.data[i+1][j+1].g) / 4 ;
	    ftar->data[i_tar][j_tar].b =  (forig.data[i][j].b + forig.data[i][j+1].b + 
					   forig.data[i+1][j].b+forig.data[i+1][j+1].b) / 4 ;
	}
    }
        
   
    printf("---writing-------- \n") ;
    ftar->write(argv[2]) ;
    return 1 ;
}
    
    
	    
    
